## ctk 0.1.0

=== CMakeLists.txt ===
###########################################################################
#
#  Library:   CTK
#
#  Copyright (c) Kitware Inc.
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0.txt
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#
###########################################################################

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.2)

#-----------------------------------------------------------------------------
# See http://cmake.org/cmake/help/cmake-2-8-docs.html#section_Policies for details
#

SET(project_policies
  CMP0001 # NEW: CMAKE_BACKWARDS_COMPATIBILITY should no longer be used.
  CMP0002 # NEW: Logical target names must be globally unique.
  CMP0003 # NEW: Libraries linked via full path no longer produce linker search paths.
  CMP0004 # NEW: Libraries linked may NOT have leading or trailing whitespace.
  CMP0005 # NEW: Preprocessor definition values are now escaped automatically.
  CMP0006 # NEW: Installing MACOSX_BUNDLE targets requires a BUNDLE DESTINATION.
  CMP0007 # NEW: List command no longer ignores empty elements.
  CMP0008 # NEW: Libraries linked by full-path must have a valid library file name.
  CMP0009 # NEW: FILE GLOB_RECURSE calls should not follow symlinks by default.
  CMP0010 # NEW: Bad variable reference syntax is an error.
  CMP0011 # NEW: Included scripts do automatic cmake_policy PUSH and POP.
  CMP0012 # NEW: if() recognizes numbers and boolean constants.
  CMP0013 # NEW: Duplicate binary directories are not allowed.
  CMP0014 # NEW: Input directories must have CMakeLists.txt
  )
FOREACH(policy ${project_policies})
  IF(POLICY ${policy})
    CMAKE_POLICY(SET ${policy} NEW)
  ENDIF()
ENDFOREACH()

#-----------------------------------------------------------------------------
if(APPLE)
  # Note: By setting CMAKE_OSX_* variables before any enable_language() or project() calls,
  #       we ensure that the bitness will be properly detected.
  include(${CMAKE_SOURCE_DIR}/CMake/ctkBlockSetCMakeOSXVariables.cmake)
endif()

#-----------------------------------------------------------------------------
PROJECT(CTK)
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# Library mode: SHARED (default) or STATIC
#
SET(CTK_LIBRARY_MODE "SHARED")

OPTION(CTK_BUILD_SHARED_LIBS "Build CTK libraries as shared module." ON)
MARK_AS_ADVANCED(CTK_BUILD_SHARED_LIBS)
IF(NOT CTK_BUILD_SHARED_LIBS)
  SET(CTK_LIBRARY_MODE "STATIC")
ENDIF()

#-----------------------------------------------------------------------------
# Set a default build type if none was specified
#
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified.")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

#-----------------------------------------------------------------------------
# Superbuild Option - Enabled by default
#
OPTION(CTK_SUPERBUILD "Build CTK and the projects it depends on via SuperBuild.cmake." ON)
MARK_AS_ADVANCED(CTK_SUPERBUILD)

#-----------------------------------------------------------------------------
# Output directories.
#
FOREACH(type LIBRARY RUNTIME ARCHIVE)
  # Make sure the directory exists
  IF(DEFINED CTK_CMAKE_${type}_OUTPUT_DIRECTORY
     AND NOT EXISTS ${CTK_CMAKE_${type}_OUTPUT_DIRECTORY})
    MESSAGE(FATAL_ERROR "CTK_CMAKE_${type}_OUTPUT_DIRECTORY is set to a non-existing directory [${CTK_CMAKE_${type}_OUTPUT_DIRECTORY}]")
  ENDIF()
  
  IF(CTK_SUPERBUILD)
    SET(output_dir ${CTK_BINARY_DIR}/bin)
    IF(NOT DEFINED CTK_CMAKE_${type}_OUTPUT_DIRECTORY)
      SET(CTK_CMAKE_${type}_OUTPUT_DIRECTORY ${CTK_BINARY_DIR}/CTK-build/bin)
    ENDIF()
  ELSE()
    IF(NOT DEFINED CTK_CMAKE_${type}_OUTPUT_DIRECTORY)
      SET(output_dir ${CTK_BINARY_DIR}/bin)
    ELSE()
      SET(output_dir ${CTK_CMAKE_${type}_OUTPUT_DIRECTORY})
    ENDIF()
  ENDIF()
  SET(CMAKE_${type}_OUTPUT_DIRECTORY ${output_dir} CACHE INTERNAL "Single output directory for building all libraries.")
ENDFOREACH()

#-----------------------------------------------------------------------------
# CTK version number.  An even minor number corresponds to releases.
#
SET(CTK_MAJOR_VERSION 0)
SET(CTK_MINOR_VERSION 1)
SET(CTK_BUILD_VERSION 0)
SET(CTK_VERSION
    "${CTK_MAJOR_VERSION}.${CTK_MINOR_VERSION}.${CTK_BUILD_VERSION}")

# Append the library version information to the library target
# properties.  A parent project may set its own properties and/or may
# block this.
IF(NOT CTK_NO_LIBRARY_VERSION)
  SET(CTK_LIBRARY_PROPERTIES ${CTK_LIBRARY_PROPERTIES}
    VERSION "${CTK_VERSION}"
    SOVERSION "${CTK_MAJOR_VERSION}.${CTK_MINOR_VERSION}"
    )
ENDIF()

#-----------------------------------------------------------------------------
# Install directories, used for install rules.
#
IF(NOT CTK_INSTALL_BIN_DIR)
  SET(CTK_INSTALL_BIN_DIR "bin")
ENDIF()
IF(NOT CTK_INSTALL_LIB_DIR)
  SET(CTK_INSTALL_LIB_DIR "lib/ctk-${CTK_MAJOR_VERSION}.${CTK_MINOR_VERSION}")
ENDIF()
IF(NOT CTK_INSTALL_INCLUDE_DIR)
  SET(CTK_INSTALL_INCLUDE_DIR "include/ctk-${CTK_MAJOR_VERSION}.${CTK_MINOR_VERSION}")
ENDIF()
IF(NOT CTK_INSTALL_DOC_DIR)
  SET(CTK_INSTALL_DOC_DIR "doc")
ENDIF()

#-----------------------------------------------------------------------------
# Update CMake module path
# Note: FindXXX.cmake script specific to utility should be copied into Utilities/CMake
#
SET(CMAKE_MODULE_PATH
  "${CMAKE_CURRENT_SOURCE_DIR}/Utilities/CMake"
  "${CMAKE_CURRENT_SOURCE_DIR}/CMake"
  ${CMAKE_MODULE_PATH})

#-----------------------------------------------------------------------------
# Clear CTK_BASE_INCLUDE_DIRS, CTK_BASE_LIBRARIES and CTK_WRAPPED_LIBRARIES_PYTHONQT
#
SET(CTK_BASE_LIBRARIES CACHE INTERNAL "CTK base libraries" FORCE)
SET(CTK_BASE_INCLUDE_DIRS CACHE INTERNAL "CTK includes" FORCE)
SET(CTK_WRAPPED_LIBRARIES_PYTHONQT CACHE INTERNAL "CTK libraries wrapped using PythonQt" FORCE)

# Variable use in CTKConfig.cmake.in
SET(CTK_LIBRARIES CACHE INTERNAL "CTK libraries" FORCE)
SET(CTK_PLUGIN_LIBRARIES CACHE INTERNAL "CTK plugins" FORCE)

# Used by CTKGenerateCTKConfig.cmake and also used to reference script from other scripts
SET(CTK_CMAKE_DIR ${CTK_SOURCE_DIR}/CMake)
SET(CTK_CMAKE_UTILITIES_DIR ${CTK_SOURCE_DIR}/Utilities/CMake)

#-----------------------------------------------------------------------------
# CMake Function(s) and Macro(s)
#
INCLUDE(CMake/ctkMacroParseArguments.cmake)
INCLUDE(CMake/ctkMacroSetPaths.cmake)
INCLUDE(CMake/ctkMacroListFilter.cmake)
INCLUDE(CMake/ctkMacroBuildLib.cmake)
INCLUDE(CMake/ctkMacroBuildPlugin.cmake)
INCLUDE(CMake/ctkMacroBuildApp.cmake)
INCLUDE(CMake/ctkMacroCompilePythonScript.cmake)
INCLUDE(CMake/ctkMacroWrapPythonQt.cmake)
INCLUDE(CMake/ctkMacroSetupQt.cmake)
INCLUDE(CMake/ctkMacroTargetLibraries.cmake) # Import multiple macros
INCLUDE(CMake/ctkFunctionExtractOptionNameAndValue.cmake)
INCLUDE(CMake/ctkMacroValidateBuildOptions.cmake)
INCLUDE(CMake/ctkMacroAddCtkLibraryOptions.cmake)
INCLUDE(CMake/ctkFunctionGenerateDGraphInput.cmake)
INCLUDE(CMake/ctkFunctionGenerateProjectXml.cmake)
INCLUDE(CMake/ctkFunctionGeneratePluginManifest.cmake)
INCLUDE(CMake/ctkMacroGeneratePluginResourceFile.cmake)
INCLUDE(CMake/ctkFunctionCheckCompilerFlags.cmake)
INCLUDE(CMake/ctkFunctionGetIncludeDirs.cmake)
INCLUDE(CMake/ctkFunctionGetLibraryDirs.cmake)
INCLUDE(CMake/ctkFunctionGetGccVersion.cmake)

#-----------------------------------------------------------------------------
# Qt Designer Plugins

OPTION(BUILD_QTDESIGNER_PLUGINS "Build Qt Designer plugins" ON)
IF(BUILD_QTDESIGNER_PLUGINS)
  INCLUDE(CMake/ctkMacroBuildQtDesignerPlugin.cmake)
ENDIF()

#-----------------------------------------------------------------------------
# Testing
#
OPTION(BUILD_TESTING "Test the project" ON)
IF(BUILD_TESTING)
  ENABLE_TESTING()
  INCLUDE(CTest)
  SET(CPP_TEST_PATH ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
  MARK_AS_ADVANCED(TCL_TCLSH DART_ROOT)
    
  # Setup file for setting custom ctest vars
  CONFIGURE_FILE(
    CMake/CTestCustom.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake
    @ONLY
    )

  # Configuration for the CMake-generated test driver
  SET(CMAKE_TESTDRIVER_EXTRA_INCLUDES "#include <stdexcept>")
  SET(CMAKE_TESTDRIVER_BEFORE_TESTMAIN "
    try
      {")
  SET(CMAKE_TESTDRIVER_AFTER_TESTMAIN "    }
      catch( std::exception & excp )
        {
        fprintf(stderr,\"%s\\n\",excp.what());
        return EXIT_FAILURE;
        }
      catch( ... )
        {
        printf(\"Exception caught in the test driver\\n\");
        return EXIT_FAILURE;
        }
      ")
ENDIF()

#-----------------------------------------------------------------------------
# Coverage
#
OPTION(WITH_COVERAGE "Enable/Disable coverage" OFF)

#-----------------------------------------------------------------------------
# Documentation
#
OPTION(DOCUMENTATION_TARGET_IN_ALL "Include the custom target for building documentation in 'all'" OFF)
MARK_AS_ADVANCED(DOCUMENTATION_TARGET_IN_ALL)

SET(DOCUMENTATION_ARCHIVES_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
 CACHE PATH "Where documentation archives should be stored")
MARK_AS_ADVANCED(DOCUMENTATION_ARCHIVES_OUTPUT_DIRECTORY)

#-----------------------------------------------------------------------------
# Additional CXX/C Flags
#
SET(ADDITIONAL_C_FLAGS "" CACHE STRING "Additional C Flags")
MARK_AS_ADVANCED(ADDITIONAL_C_FLAGS)
SET(ADDITIONAL_CXX_FLAGS "" CACHE STRING "Additional CXX Flags")
MARK_AS_ADVANCED(ADDITIONAL_CXX_FLAGS)

#-----------------------------------------------------------------------------
# Set symbol visibility Flags
#
# MinGW does not export all symbols automatically, so no need to set flags
IF(CMAKE_COMPILER_IS_GNUCXX AND NOT MINGW)
  SET(VISIBILITY_CXX_FLAGS "-fvisibility=hidden -fvisibility-inlines-hidden")
ENDIF()

#-----------------------------------------------------------------------------
# Set coverage Flags
#
IF(WITH_COVERAGE)
  IF("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    SET(coverage_flags "-g -fprofile-arcs -ftest-coverage -O0 -DNDEBUG")
    SET(COVERAGE_CXX_FLAGS ${coverage_flags})
    SET(COVERAGE_C_FLAGS ${coverage_flags})
  ENDIF()
ENDIF()

#-----------------------------------------------------------------------------
# CTK C/CXX Flags
#
SET(CTK_C_FLAGS "${CMAKE_C_FLAGS_INIT} ${COVERAGE_C_FLAGS} ${ADDITIONAL_C_FLAGS}")
SET(CTK_CXX_FLAGS "${CMAKE_CXX_FLAGS_INIT} ${VISIBILITY_CXX_FLAGS} ${COVERAGE_CXX_FLAGS} ${ADDITIONAL_CXX_FLAGS}")

IF(CMAKE_COMPILER_IS_GNUCXX)
  SET(cflags "-Wall -Wextra -Wpointer-arith -Winvalid-pch -Wcast-align -Wwrite-strings -D_FORTIFY_SOURCE=2")
  
  ctkFunctionCheckCompilerFlags("-fdiagnostics-show-option" cflags)
  ctkFunctionCheckCompilerFlags("-Wl,--no-undefined" cflags)

  ctkFunctionGetGccVersion(${CMAKE_CXX_COMPILER} GCC_VERSION)
  # With older version of gcc supporting the flag -fstack-protector-all, an extra dependency to libssp.so
  # is introduced. If gcc is smaller than 4.4.0 and the build type is Release let's not include the flag.
  # Doing so should allow to build package made for distribution using older linux distro.
  IF(${GCC_VERSION} VERSION_GREATER "4.4.0" OR (CMAKE_BUILD_TYPE STREQUAL "Debug" AND ${GCC_VERSION} VERSION_LESS "4.4.0"))
    ctkFunctionCheckCompilerFlags("-fstack-protector-all" cflags)
  ENDIF()
  IF(MINGW)

=== Documentation/CMakeLists.txt ===
FIND_PACKAGE( Doxygen QUIET)

IF( DOXYGEN_FOUND )
  IF( DOXYGEN_DOT_FOUND )

    # Compile a doxygen input filter for processing CMake scripts
    INCLUDE(ctkFunctionCMakeDoxygenFilterCompile)
    ctkFunctionCMakeDoxygenFilterCompile(NAMESPACE "CMake")

    # Automatically generate documentation at build time
    SET(all_arg)
    IF (DOCUMENTATION_TARGET_IN_ALL)
      SET(all_arg "ALL")
    ENDIF()

    #
    # User documentation
    #
    SET( CTK_USER_DOCUMENTATION "NO" )
    SET( CTK_ADDITIONAL_EXCLUDE_PATTERN "*_p.h\  *Private.*" )
    SET( CTK_DOCUMENTATION_HTML_TARZ TRUE)

    CONFIGURE_FILE( Doxyfile.txt.in
      ${CMAKE_CURRENT_BINARY_DIR}/UserDoxyfile.txt
      )

    CONFIGURE_FILE(
      ${CMAKE_CURRENT_SOURCE_DIR}/generate_doc.cmake.in
      ${CMAKE_CURRENT_BINARY_DIR}/generate_userdoc.cmake
      @ONLY
      )

    SET(userdoc_output "${CMAKE_CURRENT_BINARY_DIR}/doc/html/index.html")

    # Run doxygen as a custom command driven by a custom target.
    ADD_CUSTOM_COMMAND(
      OUTPUT ${userdoc_output}
      COMMAND ${CMAKE_COMMAND} -P "${CMAKE_CURRENT_BINARY_DIR}/generate_userdoc.cmake"
      DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/generate_userdoc.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/UserDoxyfile.txt"
      )

    ADD_CUSTOM_TARGET(doc ${all_arg} DEPENDS ${userdoc_output})
    SET_TARGET_PROPERTIES(doc PROPERTIES LABELS Documentation)

    #
    # Dev documentation
    #
    SET( CTK_USER_DOCUMENTATION "YES" )
    SET( CTK_ADDITIONAL_EXCLUDE_PATTERN "" )
    SET( CTK_ADDITIONAL_FILE_PATTERN "*.c \  *.cc \  *.cxx \  *.cpp \  *.c++ \  *.hxx \  *.hpp \  *.h++ \  *.txx \  *.C \  *.CC \  *.C++ \  *.moc" )


    CONFIGURE_FILE( Doxyfile.txt.in
      ${CMAKE_CURRENT_BINARY_DIR}/DevDoxyfile.txt
      )

    ADD_CUSTOM_TARGET( doc-dev
      ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/DevDoxyfile.txt
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/DevDoxyfile.txt
      )
    SET_TARGET_PROPERTIES(doc-dev PROPERTIES LABELS Documentation)

  ELSE( DOXYGEN_DOT_FOUND )
    MESSAGE( WARNING
      "Warning: Dot not found - Documentation will not be created"
      )
  ENDIF( DOXYGEN_DOT_FOUND )
ENDIF( DOXYGEN_FOUND )

=== Applications/ctkCLIPluginExplorer/CMakeLists.txt ===
PROJECT(ctkCLIPluginExplorer)

#
# See CTK/CMake/ctkMacroBuildApp.cmake for details
#

SET(KIT_SRCS
  ctkCLIPluginExplorerMain.cpp
)

# Headers that should run through moc
SET(KIT_MOC_SRCS
  )

# UI files
SET(KIT_UI_FORMS
)

# Resources
SET(KIT_resources
)

# Target libraries - See CMake/ctkFunctionGetTargetLibraries.cmake
# The following macro will read the target libraries from the file 'target_libraries.cmake'
ctkFunctionGetTargetLibraries(KIT_target_libraries)

ctkMacroBuildApp(
  NAME ${PROJECT_NAME}
  SRCS ${KIT_SRCS}
  MOC_SRCS ${KIT_MOC_SRCS}
  UI_FORMS ${KIT_UI_FORMS}
  TARGET_LIBRARIES ${KIT_target_libraries}
  RESOURCES ${KIT_resources}
  )

# Testing
IF(BUILD_TESTING)
#   ADD_SUBDIRECTORY(Testing)
ENDIF(BUILD_TESTING)

=== Applications/ctkDICOM/CMakeLists.txt ===
PROJECT(ctkDICOM)

#
# See CTK/CMake/ctkMacroBuildApp.cmake for details
#
  
# Source files
SET(KIT_SRCS
  ctkDICOMMain.cpp
  )

# Headers that should run through moc
SET(KIT_MOC_SRCS
  )

# UI files
SET(KIT_UI_FORMS
)

# Resources
SET(KIT_resources
)

# Target libraries - See CMake/ctkFunctionGetTargetLibraries.cmake
# The following macro will read the target libraries from the file 'target_libraries.cmake'
ctkFunctionGetTargetLibraries(KIT_target_libraries)

ctkMacroBuildApp(
  NAME ${PROJECT_NAME}
  SRCS ${KIT_SRCS}
  MOC_SRCS ${KIT_MOC_SRCS}
  UI_FORMS ${KIT_UI_FORMS}
  TARGET_LIBRARIES ${KIT_target_libraries}
  RESOURCES ${KIT_resources}
  )

# Testing
IF(BUILD_TESTING)
  #ADD_SUBDIRECTORY(Testing)
ENDIF(BUILD_TESTING)

=== Applications/ctkDICOMDemoSCU/CMakeLists.txt ===
PROJECT(ctkDICOMDemoSCU)

#
# See CTK/CMake/ctkMacroBuildLib.cmake for details
#
  
# Source files
SET(KIT_SRCS
  ctkDICOMDemoSCUMain.cpp
  )

# Headers that should run through moc
SET(KIT_MOC_SRCS
  
  )

# UI files
SET(KIT_UI_FORMS
)

# Resources
SET(KIT_resources
  )

# Target libraries - See CMake/ctkFunctionGetTargetLibraries.cmake
# The following macro will read the target libraries from the file 'target_libraries.cmake'
ctkFunctionGetTargetLibraries(KIT_target_libraries)

ctkMacroBuildApp(
  NAME ${PROJECT_NAME}
  SRCS ${KIT_SRCS}
  MOC_SRCS ${KIT_MOC_SRCS}
  UI_FORMS ${KIT_UI_FORMS}
  TARGET_LIBRARIES ${KIT_target_libraries}
  RESOURCES ${KIT_resources}
  )

# Plugins
#ADD_SUBDIRECTORY(Plugins)

# Testing
IF(BUILD_TESTING)
#  ADD_SUBDIRECTORY(Testing)
ENDIF(BUILD_TESTING)

=== Applications/ctkDICOMIndexer/CMakeLists.txt ===
PROJECT(ctkDICOMIndexer)

#
# See CTK/CMake/ctkMacroBuildApp.cmake for details
#
  
# Source files
SET(KIT_SRCS
  ctkDICOMIndexerMain.cpp
  )

# Headers that should run through moc
SET(KIT_MOC_SRCS
  )

# UI files
SET(KIT_UI_FORMS
)

# Resources
SET(KIT_resources
)

# Target libraries - See CMake/ctkFunctionGetTargetLibraries.cmake
# The following macro will read the target libraries from the file 'target_libraries.cmake'
ctkFunctionGetTargetLibraries(KIT_target_libraries)

ctkMacroBuildApp(
  NAME ${PROJECT_NAME}
  SRCS ${KIT_SRCS}
  MOC_SRCS ${KIT_MOC_SRCS}
  UI_FORMS ${KIT_UI_FORMS}
  TARGET_LIBRARIES ${KIT_target_libraries}
  RESOURCES ${KIT_resources}
  )

# Testing
IF(BUILD_TESTING)
  #ADD_SUBDIRECTORY(Testing)
ENDIF(BUILD_TESTING)

=== Applications/ctkDICOMObjectViewer/CMakeLists.txt ===
PROJECT(ctkDICOMObjectViewer)

#
# See CTK/CMake/ctkMacroBuildApp.cmake for details
#

SET(KIT_SRCS
  ctkDICOMObjectViewerMain.cpp
)

# Headers that should run through moc
SET(KIT_MOC_SRCS
)

# UI files
SET(KIT_UI_FORMS
)

# Resources
SET(KIT_resources
)

# Target libraries - See CMake/ctkFunctionGetTargetLibraries.cmake
# The following macro will read the target libraries from the file 'target_libraries.cmake'
ctkFunctionGetTargetLibraries(KIT_target_libraries)

ctkMacroBuildApp(
  NAME ${PROJECT_NAME}
  SRCS ${KIT_SRCS}
  MOC_SRCS ${KIT_MOC_SRCS}
  UI_FORMS ${KIT_UI_FORMS}
  TARGET_LIBRARIES ${KIT_target_libraries}
  RESOURCES ${KIT_resources}
  )

# Testing
IF(BUILD_TESTING)
#   ADD_SUBDIRECTORY(Testing)
ENDIF(BUILD_TESTING)

=== Applications/ctkDICOMQuery/CMakeLists.txt ===
PROJECT(ctkDICOMQuery)

#
# See CTK/CMake/ctkMacroBuildApp.cmake for details
#
  
# Source files
SET(KIT_SRCS
  ctkDICOMQueryMain.cpp
  )

# Headers that should run through moc
SET(KIT_MOC_SRCS
  )

# UI files
SET(KIT_UI_FORMS
)

# Resources
SET(KIT_resources
)

# Target libraries - See CMake/ctkFunctionGetTargetLibraries.cmake
# The following macro will read the target libraries from the file 'target_libraries.cmake'
ctkFunctionGetTargetLibraries(KIT_target_libraries)

ctkMacroBuildApp(
  NAME ${PROJECT_NAME}
  SRCS ${KIT_SRCS}
  MOC_SRCS ${KIT_MOC_SRCS}
  UI_FORMS ${KIT_UI_FORMS}
  TARGET_LIBRARIES ${KIT_target_libraries}
  RESOURCES ${KIT_resources}
  )

# Testing
IF(BUILD_TESTING)
  #ADD_SUBDIRECTORY(Testing)
ENDIF(BUILD_TESTING)

=== Applications/ctkDICOMQueryRetrieve/CMakeLists.txt ===
PROJECT(ctkDICOMQueryRetrieve)

#
# See CTK/CMake/ctkMacroBuildApp.cmake for details
#
  
# Source files
SET(KIT_SRCS
  ctkDICOMQueryRetrieveMain.cpp
  )

# Headers that should run through moc
SET(KIT_MOC_SRCS
  )

# UI files
SET(KIT_UI_FORMS
)

# Resources
SET(KIT_resources
)

# Target libraries - See CMake/ctkFunctionGetTargetLibraries.cmake
# The following macro will read the target libraries from the file 'target_libraries.cmake'
ctkFunctionGetTargetLibraries(KIT_target_libraries)

ctkMacroBuildApp(
  NAME ${PROJECT_NAME}
  SRCS ${KIT_SRCS}
  MOC_SRCS ${KIT_MOC_SRCS}
  UI_FORMS ${KIT_UI_FORMS}
  TARGET_LIBRARIES ${KIT_target_libraries}
  RESOURCES ${KIT_resources}
  )

# Testing
IF(BUILD_TESTING)
  #ADD_SUBDIRECTORY(Testing)
ENDIF(BUILD_TESTING)

=== Applications/ctkDICOMRetrieve/CMakeLists.txt ===
PROJECT(ctkDICOMRetrieve)

#
# See CTK/CMake/ctkMacroBuildApp.cmake for details
#
  
# Source files
SET(KIT_SRCS
  ctkDICOMRetrieveMain.cpp
  )

# Headers that should run through moc
SET(KIT_MOC_SRCS
  )

# UI files
SET(KIT_UI_FORMS
)

# Resources
SET(KIT_resources
)

# Target libraries - See CMake/ctkFunctionGetTargetLibraries.cmake
# The following macro will read the target libraries from the file 'target_libraries.cmake'
ctkFunctionGetTargetLibraries(KIT_target_libraries)

ctkMacroBuildApp(
  NAME ${PROJECT_NAME}
  SRCS ${KIT_SRCS}
  MOC_SRCS ${KIT_MOC_SRCS}
  UI_FORMS ${KIT_UI_FORMS}
  TARGET_LIBRARIES ${KIT_target_libraries}
  RESOURCES ${KIT_resources}
  )

# Testing
IF(BUILD_TESTING)
  #ADD_SUBDIRECTORY(Testing)
ENDIF(BUILD_TESTING)

=== Applications/ctkExampleHost/CMakeLists.txt ===
PROJECT(ctkExampleHost)

#
# See CTK/CMake/ctkMacroBuildApp.cmake for details
#

SET(KIT_SRCS
  ctkExampleHostMain.cpp
  ctkHostAppExampleWidget.cpp
)

# Headers that should run through moc
SET(KIT_MOC_SRCS
  ctkHostAppExampleWidget.h
)

# UI files
SET(KIT_UI_FORMS
  ctkExampleHostMainWindow.ui
  ctkHostAppExampleWidget.ui
)

# Resources
SET(KIT_resources
  
)

# Target libraries - See CMake/ctkFunctionGetTargetLibraries.cmake
# The following macro will read the target libraries from the file 'target_libraries.cmake'
ctkFunctionGetTargetLibraries(KIT_target_libraries)

ctkMacroBuildApp(
  NAME ${PROJECT_NAME}
  SRCS ${KIT_SRCS}
  MOC_SRCS ${KIT_MOC_SRCS}
  UI_FORMS ${KIT_UI_FORMS}
  TARGET_LIBRARIES ${KIT_target_libraries}
  RESOURCES ${KIT_resources}
  )

# Testing
IF(BUILD_TESTING)
#   ADD_SUBDIRECTORY(Testing)
ENDIF(BUILD_TESTING)

=== Applications/ctkExampleHostedApp/CMakeLists.txt ===
PROJECT(ctkExampleHostedApp)

#
# See CTK/CMake/ctkMacroBuildApp.cmake for details
#

SET(KIT_SRCS
  ctkExampleHostedAppMain.cpp
)

# Headers that should run through moc
SET(KIT_MOC_SRCS

)

# UI files
SET(KIT_UI_FORMS
  
)

# Resources
SET(KIT_resources
  
)

# Target libraries - See CMake/ctkFunctionGetTargetLibraries.cmake
# The following macro will read the target libraries from the file 'target_libraries.cmake'
ctkFunctionGetTargetLibraries(KIT_target_libraries)

ctkMacroBuildApp(
  NAME ${PROJECT_NAME}
  SRCS ${KIT_SRCS}
  MOC_SRCS ${KIT_MOC_SRCS}
  UI_FORMS ${KIT_UI_FORMS}
  TARGET_LIBRARIES ${KIT_target_libraries}
  RESOURCES ${KIT_resources}
  )

# Testing
IF(BUILD_TESTING)
#   ADD_SUBDIRECTORY(Testing)
ENDIF(BUILD_TESTING)

=== debian/changelog ===
ctk (0.1.0-4) experimental; urgency=low

  * Changed maintainer and uploader
  * build with  -DCTK_APP_ctkCLIPluginExplorer:BOOL=ON

 -- Dominique Belhachemi <domibel@debian.org>  Tue, 26 Jul 2011 20:04:04 -0400

ctk (0.1.0-3) experimental; urgency=low

  * compile log4qt with -fPIC on all archs (Closes: #634780)
  * build with  -DCTK_LIB_ImageProcessing/ITK/Core:BOOL=ON
  * build with  -DCTK_LIB_Widgets:BOOL=ON

 -- Dominique Belhachemi <domibel@debian.org>  Fri, 22 Jul 2011 19:48:05 -0400

ctk (0.1.0-2) experimental; urgency=low

  * Initial release (Closes: #601180)

 -- Dominique Belhachemi <domibel@debian.org>  Thu, 27 Jan 2011 19:25:00 -0500

=== debian/control ===
Source: ctk
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <mathieu.malaterre@gmail.com>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 8), cmake (>= 2.8.2), cdbs, libqt4-dev, libdcmtk2-dev,
 libinsighttoolkit3-dev, libgdcm2-dev, zlib1g-dev
#, libvtk5-dev
#, libpythonqt2-dev, python-dev
Standards-Version: 3.9.2
Section: libs
Homepage: http://www.commontk.org/
#Vcs-Git: git://git.debian.org/collab-maint/ctk.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/ctk.git;a=summary

Package: libctk-dev
Section: libdevel
Architecture: any
Depends: libctk0.1 (= ${binary:Version}), ${misc:Depends}
Description: toolkit for medical imaging apllication development - devel
 The goals of CTK are as follows:
    * Provide a unified set of basic programming constructs that are useful for
      medical imaging applications development
    * Facilitate the exchange and combination of code and data
    * Document, integrate, and adapt successful solutions
    * Avoid the duplication of code and data
    * Continuously extend to new tasks within the scope of the toolkit
      (medical imaging) without burdening existing tasks
 .
 This package provides the CTK header files required to compile C++ programs
 that use CTK.

Package: libctk0.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: toolkit for medical imaging apllication development - runtime
 The goals of CTK are as follows:
    * Provide a unified set of basic programming constructs that are useful for
      medical imaging applications development
    * Facilitate the exchange and combination of code and data
    * Document, integrate, and adapt successful solutions
    * Avoid the duplication of code and data
    * Continuously extend to new tasks within the scope of the toolkit
      (medical imaging) without burdening existing tasks 
 .
 This package provides the runtime binaries for CTK

Package: libctk0.1-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
    libctk0.1 (= ${binary:Version}),
    ${misc:Depends}
Description: debugging symbols for libctk0.1
 The goals of CTK are as follows:
    * Provide a unified set of basic programming constructs that are useful for
      medical imaging applications development
    * Facilitate the exchange and combination of code and data
    * Document, integrate, and adapt successful solutions
    * Avoid the duplication of code and data
    * Continuously extend to new tasks within the scope of the toolkit
      (medical imaging) without burdening existing tasks
 .
 This package contains the debugging symbols for libctk0.1

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE=0

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_CMAKE_EXTRA_FLAGS = \
	-DCMAKE_INSTALL_PREFIX:PATH=/usr \
        -DCMAKE_BUILD_TYPE:STRING=Debug \
        -DCMAKE_VERBOSE_MAKEFILE:BOOL=$(DH_VERBOSE) \
        -DCMAKE_SKIP_RPATH:BOOL=OFF \
        -DBUILD_TESTING:BOOL=ON \
        -DCTK_APP_ctkCLIPluginExplorer:BOOL=ON \
        -DCTK_LIB_ImageProcessing/ITK/Core:BOOL=ON \
        -DCTK_LIB_Widgets:BOOL=ON \
        -DCTK_LIB_Scripting/Python/Core:BOOL=OFF \
        -DCTK_LIB_DICOM/Core:BOOL=OFF \
        -DCTK_LIB_Visualization/VTK/Core:BOOL=OFF \
        -DCTK_SUPERBUILD:BOOL=OFF \


build/libctk0.1::
	- cd $(DEB_BUILDDIR) && LD_LIBRARY_PATH=`pwd`/bin:$$LD_LIBRARY_PATH ctest -VV

install/libctk0.1::
	dh_install -plibctk0.1      debian/tmp/usr/lib/*.so.*                        usr/lib
	dh_install -plibctk0.1      debian/tmp/usr/lib/*.a                           usr/lib


install/libctk-dev::
	dh_install -plibctk-dev   debian/tmp/usr/include/ctk-0.1/*                   usr/include/ctk
	dh_install -plibctk-dev   debian/tmp/usr/lib/*.so                            usr/lib
#	dh_install -plibctk-dev   debian/tmp/usr/lib/ctk-0.1/*.cmake                 usr/lib/ctk-0.1

#install/ctk-examples::
#	dh_installexamples -popenigtlink-examples Examples/

#install/ctk-doc::
#	doxygen -u $(DEB_BUILDDIR)/doxygen.config
#	doxygen $(DEB_BUILDDIR)/doxygen.config
#	dh_install -plibctk-doc       $(DEB_BUILDDIR)/Documents/Doxygen/html         usr/share/doc/ctk-doc


get-orig-source:
	/bin/sh $(CURDIR)/debian/get-orig-source

## ctk 0.9.4+bzr70

=== debian/changelog ===
ctk (0.9.4+bzr70) jaunty; urgency=low

  * Latest bzr

 -- Neil J. Patel <neil.patel@canonical.com>  Tue, 21 Jul 2009 14:28:16 +0100

ctk (0.9.4+bzr67) jaunty; urgency=low

  * Latest bzr

 -- Neil J. Patel <neil.patel@canonical.com>  Mon, 20 Jul 2009 08:52:10 +0100

ctk (0.9.4+bzr65) jaunty; urgency=low

  * Latest bzr

 -- Neil J. Patel <neil.patel@canonical.com>  Sun, 19 Jul 2009 17:13:49 +0100

ctk (0.9.4+bzr64) jaunty; urgency=low

  * Latest bzr

 -- Neil J. Patel <neil.patel@canonical.com>  Sun, 19 Jul 2009 16:26:18 +0100

ctk (0.9.4+bzr63) jaunty; urgency=low

  * Latest release

 -- Neil J. Patel <neil.patel@canonical.com>  Sun, 19 Jul 2009 13:00:51 +0100

ctk (0.9.4) jaunty; urgency=low

  * New release

 -- Neil J. Patel <neil.patel@canonical.com>  Tue, 23 Jun 2009 11:41:37 +0100

ctk (0.9.3+bzr59) jaunty; urgency=low

  * Some tooltip support

 -- Neil J. Patel <neil.patel@canonical.com>  Sun, 21 Jun 2009 15:54:47 +0100

ctk (0.9.3) jaunty; urgency=low

  * New release

 -- Neil J. Patel <neil.patel@canonical.com>  Mon, 15 Jun 2009 17:01:51 +0100

ctk (0.9.2) jaunty; urgency=low

  * New release

 -- Neil J. Patel <neil.patel@canonical.com>  Fri, 12 Jun 2009 16:34:09 +0100

ctk (0.9.1+bzr51ubuntu1) jaunty; urgency=low

  * Update to bzr trunk

 -- Neil J. Patel <neil.patel@canonical.com>  Thu, 11 Jun 2009 09:23:02 +0100

ctk (0.9.1+bzr42) jaunty; urgency=low

  * Update to the latest clutter and clutter-gtk (master)

 -- Neil J. Patel <neil.patel@canonical.com>  Mon, 08 Jun 2009 23:22:47 +0100

ctk (0.9.1+bzr35) jaunty; urgency=low

  * Got the versioning wrong, try again with +

 -- Neil J. Patel <neil.patel@canonical.com>  Sun, 07 Jun 2009 09:35:18 +0100

ctk (0.9.1~bzr35) jaunty; urgency=low

  * Enable shave
  * Enable stricter compile flags

 -- Neil J. Patel <neil.patel@canonical.com>  Sat, 06 Jun 2009 14:36:08 +0100

ctk (0.9.1) jaunty; urgency=low

  * Cleaned up autofoo to behave more like a library than a program
  * Cleaned up packaging to do the same

 -- Neil J. Patel <neil.patel@canonical.com>  Sat, 06 Jun 2009 14:04:13 +0100

libctk-1.0 (0.2.1ubuntu1) jaunty; urgency=low

  * Rebuild

 -- Neil J. Patel <neil.patel@canonical.com>  Fri, 05 Jun 2009 11:31:01 +0100

libctk-1.0 (0.2.1) jaunty; urgency=low

  * Enable -fPIC for amd64

 -- Neil J. Patel <neil.patel@canonical.com>  Fri, 05 Jun 2009 10:06:40 +0100

libctk-1.0 (0.2~bzr31) jaunty; urgency=low

  * Fix some things in the context menu signal

 -- Neil J. Patel <neil.patel@canonical.com>  Thu, 04 Jun 2009 23:14:53 +0100

libctk-1.0 (0.2~bzr29ubuntu1) jaunty; urgency=low

  * 0.2 Release

 -- Neil J. Patel <neil.patel@canonical.com>  Thu, 04 Jun 2009 19:29:23 +0100

libctk-1.0 (0.1~bzr17) jaunty; urgency=low

  * Major fixes

 -- Neil J. Patel <neil.patel@canonical.com>  Mon, 11 May 2009 18:47:34 +0100

libctk-1.0 (0.1~bzr16) jaunty; urgency=low

  * Compile with some more library flags

 -- Neil J. Patel <neil.patel@canonical.com>  Mon, 11 May 2009 16:37:37 +0100

libctk-1.0 (0.1~bzr14-ppa1) jaunty; urgency=low

  * Link to the library properly
  * Add all the headers to ctk.h

 -- Neil J. Patel <neil.patel@canonical.com>  Mon, 11 May 2009 12:33:37 +0100

libctk-1.0 (0.1~bzr13-ppa1) jaunty; urgency=low

  * Import and renaming of all the widgets

 -- Neil J. Patel <neil.patel@canonical.com>  Sun, 10 May 2009 16:21:54 +0100

libctk-1.0 (0.1) jaunty; urgency=low

  * Initial release.

 -- Neil J. Patel <neil.patel@canonical.com>  Fri, 08 May 2009 16:33:58 +0100

=== debian/control ===
Source: ctk
Section: libs
Priority: optional
Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 5.0),
               cdbs (>= 0.4.41),
               libgtk2.0-dev (>= 2.14.0),
               libclutter-0.9-dev,
               libclutter-gtk-0.9-dev,
               gtk-doc-tools
Standards-Version: 3.8.0
Homepage: https://launchpad.net/avani
Vcs-Bzr: http://bazaar.launchpad.net/~avani-team/avani/libctk-1.0

Package: libctk-0.9-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Shared library that provides a toolkit for Clutter
 libctk-1.0 is a shared library that provides a toolkit for Clutter. It
 contains layout boxes and some useful widgets such as a button.
 .
 This package contains shared libraries to be used by applications.

Package: libctk-0.9-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libctk-0.9-0 (= ${binary:Version}),
         pkg-config,
         libgtk2.0-dev (>= 2.14.0),
         libclutter-0.9-dev,
         libclutter-gtk-0.9-dev
Description: Shared library that provides a toolkit for Clutter
 libctk-1.0 is a shared library that provides a toolkit for Clutter. It
 contains layout boxes and some useful widgets such as a button.
 .
 This package contains files that are needed to build applications.

Package: libctk-0.9-dbg
Section: libdevel
Architecture: any
Priority: extra
Depends: libctk-0.9-0 (= ${binary:Version})
Description: Shared library that provides a toolkit for Clutter
 libctk-1.0 is a shared library that provides a toolkit for Clutter. It
 contains layout boxes and some useful widgets such as a button.
 .
 This package contains the debug files.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/simple-patchsys.mk
include /usr/share/cdbs/1/rules/utils.mk

DEB_CONFIGURE_SCRIPT_ENV += LDFLAGS="-Wl,-O1 -Wl,--as-needed"
DEB_COMPRESS_EXCLUDE = .c

DEB_CONFIGURE_EXTRA_FLAGS += --disable-gtk-doc

DEB_DH_MAKESHLIBS_ARGS_libctk-0.9-0 = -V 'libctk-0.9-0 (>= 0.9.1)'

common-binary-predeb-arch:: list-missing
